Index: abi/include/abi/ipc/interfaces.h
===================================================================
--- abi/include/abi/ipc/interfaces.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ abi/include/abi/ipc/interfaces.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -80,11 +80,99 @@
 typedef enum {
 	INTERFACE_LOADER =
-	    FOURCC_COMPACT('l', 'o', 'a', 'd') | IFACE_EXCHANGE_PARALLEL,
+	    FOURCC_COMPACT('l', 'o', 'a', 'd') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_LOGGER_WRITER =
+	    FOURCC_COMPACT('l', 'o', 'g', 'w') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_LOGGER_CONTROL =
+	    FOURCC_COMPACT('l', 'o', 'g', 'c') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_CORECFG =
+	    FOURCC_COMPACT('c', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_FS =
+	    FOURCC_COMPACT('f', 's', ' ', ' ') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_VFS =
+	    FOURCC_COMPACT('v', 'f', 's', ' ') | IFACE_EXCHANGE_PARALLEL,
+	INTERFACE_VFS_DRIVER =
+	    FOURCC_COMPACT('v', 'f', 's', 'd') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_VFS_DRIVER_CB =
+	    FOURCC_COMPACT('v', 'f', 's', 'd') | IFACE_EXCHANGE_PARALLEL | IFACE_MOD_CALLBACK,
+	INTERFACE_BLOCK =
+	    FOURCC_COMPACT('b', 'l', 'd', 'v') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_BLOCK_CB =
+	    FOURCC_COMPACT('b', 'l', 'd', 'v') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_CONSOLE =
+	    FOURCC_COMPACT('c', 'o', 'n', 's') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_INPUT =
+	    FOURCC_COMPACT('i', 'n', 'd', 'v') | IFACE_EXCHANGE_ATOMIC,
+	INTERFACE_INPUT_CB =
+	    FOURCC_COMPACT('i', 'n', 'd', 'v') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_OUTPUT =
+	    FOURCC_COMPACT('o', 'u', 'd', 'v') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_COMPOSITOR =
+	    FOURCC_COMPACT('c', 'm', 'p', 's') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_HOUND =
+	    FOURCC_COMPACT('h', 'o', 'u', 'n') | IFACE_EXCHANGE_PARALLEL,
+	INTERFACE_VISUALIZER_CB =
+	    FOURCC_COMPACT('v', 's', 'd', 'v') | IFACE_EXCHANGE_PARALLEL | IFACE_MOD_CALLBACK,
+	INTERFACE_LOC_SUPPLIER =
+	    FOURCC_COMPACT('l', 'o', 'c', 's') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_LOC_CONSUMER =
+	    FOURCC_COMPACT('l', 'o', 'c', 'c') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_LOC_CB =
+	    FOURCC_COMPACT('l', 'o', 'c', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_DEVMAN_DEVICE =
+	    FOURCC_COMPACT('d', 'v', 'd', 'v') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DEVMAN_PARENT =
+	    FOURCC_COMPACT('d', 'v', 'p', 't') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_IRC =
+	    FOURCC_COMPACT('i', 'r', 'c', ' ') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DDF =
+	    FOURCC_COMPACT('d', 'd', 'f', ' ') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DDF_DEVMAN =
+	    FOURCC_COMPACT('d', 'd', 'f', 'm') | IFACE_EXCHANGE_SERIALIZE,
 	INTERFACE_DDF_CLIENT =
 	    FOURCC_COMPACT('d', 'd', 'f', 'c') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DDF_DRIVER =
+	    FOURCC_COMPACT('d', 'd', 'f', 'd') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_INET =
+	    FOURCC_COMPACT('i', 'n', 'e', 't') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_INET_CB =
+	    FOURCC_COMPACT('i', 'n', 'e', 't') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_INETCFG =
+	    FOURCC_COMPACT('i', 'c', 'f', 'g') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_INETPING =
+	    FOURCC_COMPACT('i', 'p', 'n', 'g') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_INETPING_CB =
+	    FOURCC_COMPACT('i', 'p', 'n', 'g') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_DHCP =
+	    FOURCC_COMPACT('d', 'h', 'c', 'p') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_DNSR =
+	    FOURCC_COMPACT('d', 'n', 's', 'r') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_IPLINK =
+	    FOURCC_COMPACT('i', 'p', 'l', 'k') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_IPLINK_CB =
+	    FOURCC_COMPACT('i', 'p', 'l', 'k') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_TCP =
+	    FOURCC_COMPACT('t', 'c', 'p', ' ') | IFACE_EXCHANGE_SERIALIZE,
 	INTERFACE_TCP_CB =
 	    FOURCC_COMPACT('t', 'c', 'p', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_UDP =
+	    FOURCC_COMPACT('u', 'd', 'p', ' ') | IFACE_EXCHANGE_SERIALIZE,
 	INTERFACE_UDP_CB =
-	    FOURCC_COMPACT('u', 'd', 'p', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK
+	    FOURCC_COMPACT('u', 'd', 'p', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_CLIPBOARD =
+	    FOURCC_COMPACT('c', 'l', 'i', 'p') | IFACE_EXCHANGE_SERIALIZE,
+	INTERFACE_CHAR_CB =
+	    FOURCC_COMPACT('b', 'l', 'd', 'v') | IFACE_EXCHANGE_PARALLEL | IFACE_MOD_CALLBACK,
+	INTERFACE_AUDIO_PCM_CB =
+	    FOURCC_COMPACT('a', 'p', 'c', 'm') | IFACE_EXCHANGE_PARALLEL | IFACE_MOD_CALLBACK,
+	INTERFACE_NIC_CB =
+	    FOURCC_COMPACT('n', 'i', 'c', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_USBVIRT_CB =
+	    FOURCC_COMPACT('u', 's', 'b', 'v') | IFACE_EXCHANGE_PARALLEL | IFACE_MOD_CALLBACK,
+	INTERFACE_ADB_CB =
+	    FOURCC_COMPACT('a', 'd', 'b', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_MOUSE_CB =
+	    FOURCC_COMPACT('m', 'o', 'u', 's') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK,
+	INTERFACE_KBD_CB =
+	    FOURCC_COMPACT('k', 'b', 'd', ' ') | IFACE_EXCHANGE_SERIALIZE | IFACE_MOD_CALLBACK
 } iface_t;
 
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/barber/barber.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -267,5 +267,5 @@
 			link_initialize(&dev->link);
 			dev->svc_id = svcs[i];
-			dev->sess = loc_service_connect_iface(svcs[i], INTERFACE_DDF_CLIENT, 0);
+			dev->sess = loc_service_connect(svcs[i], INTERFACE_DDF, 0);
 			
 			list_append(&dev->link, &led_devs);
Index: uspace/app/date/date.c
===================================================================
--- uspace/app/date/date.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/date/date.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -136,6 +136,5 @@
 
 	/* Connect to the device */
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE,
-	    svc_id, 0);
+	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF, 0);
 	if (!sess) {
 		printf(NAME ": Cannot connect to the device\n");
Index: uspace/app/mixerctl/mixerctl.c
===================================================================
--- uspace/app/mixerctl/mixerctl.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/mixerctl/mixerctl.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -155,6 +155,5 @@
 	}
 
-	async_sess_t *session = loc_service_connect(
-	    EXCHANGE_ATOMIC, mixer_sid, 0);
+	async_sess_t *session = loc_service_connect(mixer_sid, INTERFACE_DDF, 0);
 	if (!session) {
 		printf("Failed connecting mixer service '%s'.\n", service);
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/mkbd/main.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -231,6 +231,5 @@
 	}
 	
-	async_sess_t *sess = devman_device_connect(EXCHANGE_SERIALIZE,
-	    dev_handle, 0);
+	async_sess_t *sess = devman_device_connect(dev_handle, 0);
 	if (!sess) {
 		printf(NAME ": failed to connect to the device (handle %"
Index: uspace/app/nic/nic.c
===================================================================
--- uspace/app/nic/nic.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/nic/nic.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -99,5 +99,5 @@
 	printf("Using device: %s\n", svc_name);
 
-	sess = loc_service_connect(EXCHANGE_SERIALIZE, nics[i], 0);
+	sess = loc_service_connect(nics[i], INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("Error connecting to service.\n");
@@ -117,10 +117,10 @@
 	int rc;
 
-	sess = loc_service_connect(EXCHANGE_SERIALIZE, svc_id, 0);
+	sess = loc_service_connect(svc_id, INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("Error connecting to service.\n");
 		goto error;
 	}
-
+	
 	rc = nic_get_address(sess, &info->address);
 	if (rc != EOK) {
Index: uspace/app/sportdmp/sportdmp.c
===================================================================
--- uspace/app/sportdmp/sportdmp.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/sportdmp/sportdmp.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -111,5 +111,5 @@
 
 
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE, svc_id,
+	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
 	if (!sess) {
Index: uspace/app/tester/hw/misc/virtchar1.c
===================================================================
--- uspace/app/tester/hw/misc/virtchar1.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/tester/hw/misc/virtchar1.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -69,5 +69,5 @@
 	
 	TPRINTF(" Asking for session...\n");
-	async_sess_t *sess = fd_session(EXCHANGE_SERIALIZE, fd);
+	async_sess_t *sess = fd_session(fd, INTERFACE_DDF);
 	if (!sess) {
 		close(fd);
Index: uspace/app/tester/hw/serial/serial1.c
===================================================================
--- uspace/app/tester/hw/serial/serial1.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/tester/hw/serial/serial1.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -76,5 +76,5 @@
 		return "Failed getting serial port service ID";
 	
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE, svc_id,
+	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
 	if (!sess)
Index: uspace/app/wifi_supplicant/wifi_supplicant.c
===================================================================
--- uspace/app/wifi_supplicant/wifi_supplicant.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/app/wifi_supplicant/wifi_supplicant.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -121,5 +121,5 @@
 	
 	async_sess_t *sess =
-	    loc_service_connect(EXCHANGE_SERIALIZE, wifis[i], 0);
+	    loc_service_connect(wifis[i], INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("Error connecting to service.\n");
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -175,6 +175,5 @@
 
 	ddf_msg(LVL_NOTE, "create parent sess");
-	hda->parent_sess = ddf_dev_parent_sess_create(dev,
-	    EXCHANGE_SERIALIZE);
+	hda->parent_sess = ddf_dev_parent_sess_create(dev);
 	if (hda->parent_sess == NULL) {
 		ddf_msg(LVL_ERROR, "Failed connecting parent driver.\n");
Index: uspace/drv/audio/sb16/dsp.c
===================================================================
--- uspace/drv/audio/sb16/dsp.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/audio/sb16/dsp.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -159,5 +159,5 @@
 static inline int setup_dma(sb_dsp_t *dsp, uintptr_t pa, size_t size)
 {
-	async_sess_t *sess = devman_parent_device_connect(EXCHANGE_ATOMIC,
+	async_sess_t *sess = devman_parent_device_connect(
 	    ddf_dev_get_handle(dsp->sb_dev), IPC_FLAG_BLOCKING);
 
@@ -307,5 +307,5 @@
 
 	assert(dsp->buffer.data);
-	async_sess_t *sess = devman_parent_device_connect(EXCHANGE_ATOMIC,
+	async_sess_t *sess = devman_parent_device_connect(
 	    ddf_dev_get_handle(dsp->sb_dev), IPC_FLAG_BLOCKING);
 
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/audio/sb16/main.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -178,5 +178,5 @@
 
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -245,5 +245,5 @@
 {
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/block/ahci/ahci.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -1140,5 +1140,5 @@
 	
 	/* Connect to parent device */
-	ahci->parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	ahci->parent_sess = ddf_dev_parent_sess_create(dev);
 	if (ahci->parent_sess == NULL)
 		return NULL;
Index: uspace/drv/block/ata_bd/main.c
===================================================================
--- uspace/drv/block/ata_bd/main.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/block/ata_bd/main.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -68,6 +68,5 @@
 	int rc;
 
-	parent_sess = ddf_dev_parent_sess_create(dev,
-	    EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/block/ddisk/ddisk.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -286,5 +286,5 @@
 	int rc;
 
-	parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
Index: uspace/drv/bus/amba/amba.c
===================================================================
--- uspace/drv/bus/amba/amba.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/amba/amba.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -333,5 +333,5 @@
 	
 	bus->dnode = dnode;
-	async_sess_t *sess = ddf_dev_parent_sess_create(dnode, EXCHANGE_SERIALIZE);
+	async_sess_t *sess = ddf_dev_parent_sess_create(dnode);
 	if (sess == NULL) {
 		ddf_msg(LVL_ERROR, "amba_dev_add failed to connect to the "
Index: uspace/drv/bus/isa/isa.c
===================================================================
--- uspace/drv/bus/isa/isa.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/isa/isa.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -616,5 +616,5 @@
 	list_initialize(&isa->functions);
 
-	sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	sess = ddf_dev_parent_sess_create(dev);
 	if (sess == NULL) {
 		ddf_msg(LVL_ERROR, "isa_dev_add failed to connect to the "
Index: uspace/drv/bus/pci/pciintel/pci.c
===================================================================
--- uspace/drv/bus/pci/pciintel/pci.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/pci/pciintel/pci.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -664,5 +664,5 @@
 	bus->dnode = dnode;
 	
-	sess = ddf_dev_parent_sess_create(dnode, EXCHANGE_SERIALIZE);
+	sess = ddf_dev_parent_sess_create(dnode);
 	if (sess == NULL) {
 		ddf_msg(LVL_ERROR, "pci_dev_add failed to connect to the "
Index: uspace/drv/bus/usb/ehci/res.c
===================================================================
--- uspace/drv/bus/usb/ehci/res.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/usb/ehci/res.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -81,5 +81,5 @@
 	
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(dev), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(dev), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -115,5 +115,5 @@
 {
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -138,5 +138,5 @@
 
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/drv/bus/usb/ohci/res.c
===================================================================
--- uspace/drv/bus/usb/ohci/res.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/usb/ohci/res.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -57,6 +57,6 @@
 
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE,
-	    ddf_dev_get_handle(dev), IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(ddf_dev_get_handle(dev),
+	    IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -93,6 +93,6 @@
 {
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE,
-	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(ddf_dev_get_handle(device),
+	    IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/drv/bus/usb/uhci/res.c
===================================================================
--- uspace/drv/bus/usb/uhci/res.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/usb/uhci/res.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -55,6 +55,6 @@
 
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE,
-	    ddf_dev_get_handle(dev), IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(ddf_dev_get_handle(dev),
+	    IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -91,6 +91,6 @@
 {
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE,
-	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(ddf_dev_get_handle(device),
+	    IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
@@ -112,5 +112,5 @@
 
 	async_sess_t *parent_sess = devman_parent_device_connect(
-	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	    ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/drv/bus/usb/uhcirh/main.c
===================================================================
--- uspace/drv/bus/usb/uhcirh/main.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/bus/usb/uhcirh/main.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -131,6 +131,6 @@
 {
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_SERIALIZE,
-	    ddf_dev_get_handle(dev), IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(ddf_dev_get_handle(dev),
+	    IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/drv/char/grlib_uart/grlib_uart.c
===================================================================
--- uspace/drv/char/grlib_uart/grlib_uart.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/grlib_uart/grlib_uart.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -381,6 +381,5 @@
 	
 	/* Connect to the parent's driver. */
-	async_sess_t *parent_sess = ddf_dev_parent_sess_create(ns->dev,
-	    EXCHANGE_SERIALIZE);
+	async_sess_t *parent_sess = ddf_dev_parent_sess_create(ns->dev);
 	if (parent_sess == NULL) {
 		ddf_msg(LVL_ERROR, "Failed to connect to parent driver of "
Index: uspace/drv/char/i8042/main.c
===================================================================
--- uspace/drv/char/i8042/main.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/i8042/main.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -61,6 +61,5 @@
 	assert(dev);
 	
-	async_sess_t *parent_sess = ddf_dev_parent_sess_create(
-	    dev, EXCHANGE_SERIALIZE);
+	async_sess_t *parent_sess = ddf_dev_parent_sess_create(dev);
 	if (parent_sess == NULL)
 		return ENOMEM;
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/ns8250/ns8250.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -391,5 +391,5 @@
 	
 	/* Connect to the parent's driver. */
-	parent_sess = ddf_dev_parent_sess_create(ns->dev, EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(ns->dev);
 	if (parent_sess == NULL) {
 		ddf_msg(LVL_ERROR, "Failed to connect to parent driver of "
Index: uspace/drv/char/pl050/pl050.c
===================================================================
--- uspace/drv/char/pl050/pl050.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/pl050/pl050.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -167,6 +167,5 @@
 	pl050->buf_rp = pl050->buf_wp = 0;
 
-	pl050->parent_sess = ddf_dev_parent_sess_create(pl050->dev,
-	    EXCHANGE_SERIALIZE);
+	pl050->parent_sess = ddf_dev_parent_sess_create(pl050->dev);
 	if (pl050->parent_sess == NULL) {
 		ddf_msg(LVL_ERROR, "Failed connecitng parent driver.");
Index: uspace/drv/char/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/char/ps2mouse/ps2mouse.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/ps2mouse/ps2mouse.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -116,5 +116,5 @@
 {
 	mouse->client_sess = NULL;
-	mouse->parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	mouse->parent_sess = ddf_dev_parent_sess_create(dev);
 	if (!mouse->parent_sess)
 		return ENOMEM;
Index: uspace/drv/char/xtkbd/xtkbd.c
===================================================================
--- uspace/drv/char/xtkbd/xtkbd.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/char/xtkbd/xtkbd.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -417,5 +417,5 @@
 	
 	kbd->client_sess = NULL;
-	kbd->parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	kbd->parent_sess = ddf_dev_parent_sess_create(dev);
 	
 	if (!kbd->parent_sess) {
Index: uspace/drv/time/cmos-rtc/cmos-rtc.c
===================================================================
--- uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -213,5 +213,5 @@
 	/* Connect to the parent's driver */
 
-	parent_sess = ddf_dev_parent_sess_create(rtc->dev, EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(rtc->dev);
 	if (!parent_sess) {
 		ddf_msg(LVL_ERROR, "Failed to connect to parent driver\
Index: uspace/lib/block/block.c
===================================================================
--- uspace/lib/block/block.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/block/block.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -148,5 +148,5 @@
 	bd_t *bd;
 
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE, service_id,
+	async_sess_t *sess = loc_service_connect(service_id, INTERFACE_BLOCK,
 	    IPC_FLAG_BLOCKING);
 	if (!sess) {
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/async.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -2105,5 +2105,4 @@
  * @param arg2            User defined argument.
  * @param arg3            User defined argument.
- * @param client_receiver Connection handing routine.
  *
  * @return Zero on success or a negative error code.
@@ -2111,25 +2110,17 @@
  */
 int async_connect_to_me(async_exch_t *exch, sysarg_t arg1, sysarg_t arg2,
-    sysarg_t arg3, async_port_handler_t client_receiver, void *data)
+    sysarg_t arg3)
 {
 	if (exch == NULL)
 		return ENOENT;
 	
-	sysarg_t phone_hash;
+	ipc_call_t answer;
+	aid_t req = async_send_3(exch, IPC_M_CONNECT_TO_ME, arg1, arg2, arg3,
+	    &answer);
+	
 	sysarg_t rc;
-
-	aid_t req;
-	ipc_call_t answer;
-	req = async_send_3(exch, IPC_M_CONNECT_TO_ME, arg1, arg2, arg3,
-	    &answer);
 	async_wait_for(req, &rc);
 	if (rc != EOK)
 		return (int) rc;
-
-	phone_hash = IPC_GET_ARG5(answer);
-
-	if (client_receiver != NULL)
-		async_new_connection(answer.in_task_id, phone_hash, 0, NULL,
-		    client_receiver, data);
 	
 	return EOK;
@@ -2261,5 +2252,4 @@
 	int phone = async_connect_me_to_internal(exch->phone, arg1, arg2, arg3,
 	    0);
-	
 	if (phone < 0) {
 		errno = phone;
Index: uspace/lib/c/generic/bd.c
===================================================================
--- uspace/lib/c/generic/bd.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/bd.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -57,5 +57,8 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 	
-	int rc = async_connect_to_me(exch, 0, 0, 0, bd_cb_conn, bd);
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_BLOCK_CB, 0, 0,
+	    bd_cb_conn, bd, &port);
+	
 	async_exchange_end(exch);
 	
Index: uspace/lib/c/generic/clipboard.c
===================================================================
--- uspace/lib/c/generic/clipboard.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/clipboard.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -61,6 +61,6 @@
 	
 	while (clip_sess == NULL)
-		clip_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-		    SERVICE_CLIPBOARD, 0);
+		clip_sess = service_connect_blocking(SERVICE_CLIPBOARD,
+		    INTERFACE_CLIPBOARD, 0);
 	
 	fibril_mutex_unlock(&clip_mutex);
Index: uspace/lib/c/generic/corecfg.c
===================================================================
--- uspace/lib/c/generic/corecfg.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/corecfg.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -50,5 +50,5 @@
 		return ENOENT;
 
-	corecfg_sess = loc_service_connect(EXCHANGE_SERIALIZE, corecfg_svc,
+	corecfg_sess = loc_service_connect(corecfg_svc, INTERFACE_CORECFG,
 	    IPC_FLAG_BLOCKING);
 	if (corecfg_sess == NULL)
